﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="CurrencyEditor.ascx.cs"
  Inherits="Core.Web.Admin.Controls.Editor.CurrencyEditor" %>
<%@ Import Namespace="Core.DBO.Service.Security" %>
<%@ Import Namespace="Core.DBO.Static" %>
<%@ Import Namespace="Core.Web.Objects.Utility" %>
<%@ Import Namespace="Core.DBO.Entity" %>
<%@ Import Namespace="Core.Web" %>
<%@ Import Namespace="Core.Web.Objects" %>
<%@ Import Namespace="Core.Web.Constants.UI" %>
<%@ Register Src="~/Admin/Controls/HorizontalButtonsPanel.ascx" TagPrefix="uc" TagName="ButtonsPanel" %>
<table cellspacing="15" cellpadding="0" border="0" class="data">
  <tbody>
    <tr>
      <td class="form1">
        <div class="error">
          <UI:ValidationSummary runat="server" ID="Errors" />
        </div>
        <UI:ActionResultView runat="server" ID="CustomActionResult" />
        <fieldset>
          <Control:CollapsableBox runat="server" ID="Messages" IsCollapsable="true">
            <Header>
              <h3 class="delimiter">
                <span>
                  <%= UI.Current.CurrencyDetails%></span></h3>
            </Header>
            <Body>
              <div class="form-content">
                <table class="line-form">
                  <tbody>
                    <tr class="<%=GetRegionCSSClass(CodeTextBox)%>">
                      <td class="label">
                        <UI:FieldView runat="server" ID="CodeFieldView" InputToDisplayID="CodeTextBox" />
                      </td>
                      <td class="control">
                        <UI:TextBox runat="server" ID="CodeTextBox" Template-PropertyName="CurrencyCode"
                          ExtendedTemplate-HighlightOnFocus="true" />
                      </td>
                    </tr>
                    <tr class="<%=GetRegionCSSClass(NameTextBox)%>">
                      <td class="label">
                        <UI:FieldView runat="server" ID="NameFieldView" InputToDisplayID="NameTextBox" />
                      </td>
                      <td class="control">
                        <UI:TextBox runat="server" ID="NameTextBox" Template-PropertyName="Name" ExtendedTemplate-HighlightOnFocus="true" />
                      </td>
                    </tr>
                    <tr class="<%=GetRegionCSSClass(DescriptionTextBox)%>">
                      <td class="label">
                        <UI:FieldView runat="server" ID="DescriptionFieldView" InputToDisplayID="DescriptionTextBox" />
                      </td>
                      <td class="control">
                        <UI:TextBox runat="server" ID="DescriptionTextBox" Template-PropertyName="Description"
                          ExtendedTemplate-HighlightOnFocus="true" />
                      </td>
                    </tr>
                    <tr class="<%=GetRegionCSSClass(CurrensySymbolTextBox)%>">
                      <td class="label">
                        <UI:FieldView runat="server" ID="CurrensySymbolFieldView" InputToDisplayID="CurrensySymbolTextBox" />
                      </td>
                      <td class="control">
                        <UI:TextBox runat="server" ID="CurrensySymbolTextBox" Template-PropertyName="CurrencySymbol"
                          ExtendedTemplate-HighlightOnFocus="true" />
                      </td>
                    </tr>
                    <tr class="<%=GetRegionCSSClass(SymbolIsBeforeValueCheckBox)%>">
                      <td class="label">
                        <UI:FieldView runat="server" ID="SymbolIsBeforeValueFieldView" InputToDisplayID="SymbolIsBeforeValueCheckBox" />
                      </td>
                      <td class="control">
                        <UI:CheckBox runat="server" ID="SymbolIsBeforeValueCheckBox" Template-PropertyName="SymbolIsBeforeValue"
                          ExtendedTemplate-HighlightOnFocus="true" />
                      </td>
                    </tr>
                    <tr class="<%=GetRegionCSSClass(InsertSpaceCheckBox)%>">
                      <td class="label">
                        <UI:FieldView runat="server" ID="InsertSpaceFieldView" InputToDisplayID="InsertSpaceCheckBox"/>
                      </td>
                      <td class="control">
                        <UI:CheckBox runat="server" ID="InsertSpaceCheckBox" ExtendedTemplate-HighlightOnFocus="true" 
                        Template-DisplayName="Insert space between value and currency symbol"/>
                      </td>
                    </tr>
                  </tbody>
                </table>
              </div>
            </Body>
          </Control:CollapsableBox>
        </fieldset>
      </td>
    </tr>
    <tr>
      <td>
        <uc:ButtonsPanel runat="server" ID="Buttons" />
        <span class="obligatory-fields">
          <%=UI.Current.RequiredMessage%></span>
      </td>
    </tr>
  </tbody>
</table>
