﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="OrderEditor.ascx.cs" Inherits="Core.Web.Admin.Controls.Editor.OrderEditor" %>
<%@ Import Namespace="Core.DBO.Service.Security" %>
<%@ Import Namespace="Core.DBO.Static" %>
<%@ Import Namespace="Core.Web.Objects.Utility" %>
<%@ Import Namespace="Core.DBO.Entity" %>
<%@ Import Namespace="Core.Web" %>
<%@ Import Namespace="Core.Web.Objects" %>
<%@ Import namespace="Core.Web.Constants.UI"%>
<%@ Register Src="~/Admin/Controls/HorizontalButtonsPanel.ascx" TagPrefix="uc" TagName="ButtonsPanel" %>
<table cellspacing="15" cellpadding="0" border="0" class="data">
  <tbody>
    <tr>
      <td class="form1">
        <div class="error"><UI:ValidationSummary runat="server" ID="Errors" /></div>
        <UI:ActionResultView runat="server" ID="CustomActionResult" />
        <fieldset>
          <Control:CollapsableBox runat="server" ID="Messages" IsCollapsable="true">
            <Header>
              <h3 class="delimiter"><span><%=UI.Current.OrderDetails %></span></h3>
            </Header>
            <Body>
              <div class="form-content">
                <table class="line-form">
                  <tbody>
                    <%if (!Entity.IsNew) {%>
                    <tr class="<%=GetRegionCSSClass(OrderIDField)%>">
                      <td class="label">
                        <UI:FieldView runat="server" ID="OrderIDFieldView" InputToDisplayID="OrderIDField" />
                      </td>
                      <td class="control">
                        <UI:TextBox id="OrderIDField" runat="server" Template-PropertyName="PaymentOrderID" ExtendedTemplate-HighlightOnFocus="true" Enabled="false"/>
                      </td>
                    </tr>
                    <% } %>
                    <tr class="<%=GetRegionCSSClass(PostedDateField)%>">
                      <td class="label">
                        <UI:FieldView runat="server" ID="PostedDateFieldView" InputToDisplayID="PostedDateField" />
                      </td>
                      <td class="control">
                        <UI:DateTextBox id="PostedDateField" runat="server" Template-PropertyName="PostedDate" ExtendedTemplate-HighlightOnFocus="true" />
                      </td>
                    </tr>
                    <tr class="<%=GetRegionCSSClass(EmailField)%>">
                      <td class="label">
                        <UI:FieldView runat="server" ID="EmailFieldView" InputToDisplayID="EmailField" />
                      </td>
                      <td class="control">
                        <UI:TextBox runat="server" ID="EmailField" Template-PropertyName="Email" ExtendedTemplate-HighlightOnFocus="true" />
                      </td>
                    </tr>
                    <tr class="<%=GetRegionCSSClass(StatusField)%>">
                      <td class="label">
                        <UI:FieldView runat="server" ID="OrderStatusFieldView" InputToDisplayID="StatusField" />
                      </td>
                      <td class="control">
                        <UI:DropDownList id="StatusField" runat="server" Template-PropertyName="PaymentOrderStatus" ExtendedTemplate-HighlightOnFocus="true"/>
                      </td>
                    </tr>
                  </tbody>
                </table>
              </div>
            </Body>
          </Control:CollapsableBox>
        </fieldset>

        <fieldset>
          <Control:CollapsableBox runat="server" ID="CustomerInfoBox" IsCollapsable="true">
            <Header>
                <h3 class="delimiter"><span><%=UI.Current.CustomerInformation %></span></h3>
            </Header>
            <Body>
              <div class="form-content">
                <table class="line-form">
                  <tbody>
                    <tr class="<%=GetRegionCSSClass(CustomerFirstNameField)%>">
                      <td class="label">
                        <UI:FieldView runat="server" ID="CustomerFirstNameFieldView" InputToDisplayID="CustomerFirstNameField" />
                      </td>
                      <td class="control">
                        <UI:TextBox id="CustomerFirstNameField" runat="server" Template-PropertyName="CustomerProfile.FirstName" ExtendedTemplate-HighlightOnFocus="true" ReadOnly="true"/>
                      </td>
                    </tr>
                    <tr class="<%=GetRegionCSSClass(CustomerLastNameField)%>">
                      <td class="label">
                        <UI:FieldView runat="server" ID="CustomerLastNameFieldView" InputToDisplayID="CustomerLastNameField" />
                      </td>
                      <td class="control">
                        <UI:TextBox id="CustomerLastNameField" runat="server" Template-PropertyName="CustomerProfile.LastName" ExtendedTemplate-HighlightOnFocus="true" ReadOnly="true"/>
                      </td>
                    </tr>
                    <tr class="<%=GetRegionCSSClass(DeliveryAddress1Field)%>">
                      <td class="label">
                        <UI:FieldView runat="server" ID="DeliveryAddress1FieldView" InputToDisplayID="DeliveryAddress1Field" />
                      </td>
                      <td class="control">
                        <UI:TextBox id="DeliveryAddress1Field" runat="server" Template-PropertyName="CustomerProfile.Address" ExtendedTemplate-HighlightOnFocus="true" ReadOnly="true"/>
                      </td>
                    </tr>
                    <%if (Entity.CustomerProfile != null && !String.IsNullOrEmpty(Entity.CustomerProfile.Address2)) {%>
                    <tr class="<%=GetRegionCSSClass(DeliveryAddress2Field)%>">
                      <td class="label">
                        <UI:FieldView runat="server" ID="DeliveryAddress2FieldView" InputToDisplayID="DeliveryAddress2Field" />
                      </td>
                      <td class="control">
                        <UI:TextBox id="DeliveryAddress2Field" runat="server" Template-PropertyName="CustomerProfile.Address2" ExtendedTemplate-HighlightOnFocus="true" ReadOnly="true"/>
                      </td>
                    </tr>
                   <% }%>
                    <tr class="<%=GetRegionCSSClass(DeliveryTownField)%>">
                      <td class="label">
                        <UI:FieldView runat="server" ID="DeliveryTownFieldView" InputToDisplayID="DeliveryTownField" />
                      </td>
                      <td class="control">
                        <UI:TextBox id="DeliveryTownField" runat="server" Template-PropertyName="CustomerProfile.Town.Name" Template-DisplayName="Town" ExtendedTemplate-HighlightOnFocus="true" ReadOnly="true"/>
                      </td>
                    </tr>
                    <tr class="<%=GetRegionCSSClass(DeliveryPostcodeField)%>">
                      <td class="label">
                        <UI:FieldView runat="server" ID="DeliveryPostcodeFieldView" InputToDisplayID="DeliveryPostcodeField" />
                      </td>
                      <td class="control">
                        <UI:TextBox id="DeliveryPostcodeField" runat="server" Template-PropertyName="CustomerProfile.Postcode" ExtendedTemplate-HighlightOnFocus="true" ReadOnly="true"/>
                      </td>
                    </tr>
                  <%if (Entity.CustomerProfile != null) {%>
                    <%if (!String.IsNullOrEmpty(Entity.CustomerProfile.Phone)) {%>
                    <tr class="<%=GetRegionCSSClass(CustomerPhoneField)%>">
                      <td class="label">
                        <UI:FieldView runat="server" ID="CustomerPhoneFieldView" InputToDisplayID="CustomerPhoneField" />
                      </td>
                      <td class="control">
                      <UI:TextBox id="CustomerPhoneField" runat="server" Template-PropertyName="CustomerProfile.Phone" ExtendedTemplate-HighlightOnFocus="true" ReadOnly="true"/>
                      </td>
                    </tr>
                    <% }%>
                    
                    <%if (!String.IsNullOrEmpty(Entity.CustomerProfile.Mobile)) {%>
                    <tr class="<%=GetRegionCSSClass(CustomerMobileField)%>">
                      <td class="label">
                        <UI:FieldView runat="server" ID="CustomerMobileFieldView" InputToDisplayID="CustomerMobileField" />
                      </td>
                      <td class="control">
                        <UI:TextBox id="CustomerMobileField" runat="server" Template-PropertyName="CustomerProfile.Mobile" ExtendedTemplate-HighlightOnFocus="true" ReadOnly="true"/>
                      </td>
                    </tr>
                    <% }%>
                    
                    <%if (!String.IsNullOrEmpty(Entity.CustomerProfile.Fax)) {%>
                    <tr class="<%=GetRegionCSSClass(CustomerFaxField)%>">
                      <td class="label">
                        <UI:FieldView runat="server" ID="CustomerFaxFieldView" InputToDisplayID="CustomerFaxField" />
                      </td>
                      <td class="control">
                        <UI:TextBox id="CustomerFaxField" runat="server" Template-PropertyName="CustomerProfile.Fax" ExtendedTemplate-HighlightOnFocus="true" ReadOnly="true"/>
                      </td>
                    </tr>
                    <% } %>
                  <% } %>                                       
                  </tbody>
                </table>
              </div>
            </Body>
          </Control:CollapsableBox>
        </fieldset>

        <fieldset>
          <Control:CollapsableBox runat="server" ID="TotlaInfoBox" IsCollapsable="true">
            <Header>
              <h3 class="delimiter"><span><%=UI.Current.TotalInformation %></span></h3>
            </Header>
            <Body>
              <div class="form-content">
                <table class="line-form">
                    <tbody>
                      <tr class="<%=GetRegionCSSClass(DeliveryChargeField)%>">
                        <td class="label">
                          <UI:FieldView runat="server" ID="DeliveryChargeFieldView" 
                          InputToDisplayID="DeliveryChargeField" />
                        </td>
                        <td class="control">
                          <UI:DropDownList id="DeliveryChargeField" runat="server" Template-PropertyName="DeliveryCharge" ExtendedTemplate-HighlightOnFocus="true"/>
                        </td>
                      </tr>                      
                      <tr class="<%=GetRegionCSSClass(TotalField)%>">
                        <td class="label">
                          <UI:FieldView runat="server" ID="TotalFieldView" InputToDisplayID="TotalField" />
                        </td>
                        <td class="control">
                          <UI:TextBox id="TotalField" runat="server" Template-PropertyName="Total" ExtendedTemplate-HighlightOnFocus="true" />
                        </td>
                      </tr>                      
                      <tr class="<%=GetRegionCSSClass(DiscountField)%>">
                        <td class="label">
                          <UI:FieldView runat="server" ID="DiscountFieldView" InputToDisplayID="DiscountField" />
                        </td>
                        <td class="control">
                          <UI:TextBox id="DiscountField" runat="server" Template-PropertyName="Discount" ExtendedTemplate-HighlightOnFocus="true"/>
                        </td>
                      </tr>
                      <tr class="<%=GetRegionCSSClass(GiftVouchersAmountField)%>">
                        <td class="label">
                          <UI:FieldView runat="server" ID="GiftVouchersAmountFieldView" InputToDisplayID="GiftVouchersAmountField" />
                        </td>
                        <td class="control">
                          <UI:TextBox id="GiftVouchersAmountField" runat="server" Template-PropertyName="GiftVouchersAmount" ExtendedTemplate-HighlightOnFocus="true"/>
                        </td>
                      </tr>                      
                      
                      <tr class="<%=GetRegionCSSClass(VATField)%>">
                        <td class="label">
                          <UI:FieldView runat="server" ID="VATFieldView" InputToDisplayID="VATField" />
                        </td>
                        <td class="control">
                          <UI:TextBox id="VATField" runat="server" Template-PropertyName="VAT" ExtendedTemplate-HighlightOnFocus="true" />
                        </td>
                      </tr>
                        
                      <tr class="<%=GetRegionCSSClass(DeliveryChargeAmountField)%>">
                        <td class="label">
                          <UI:FieldView runat="server" ID="DeliveryChargeAmountFieldView" InputToDisplayID="DeliveryChargeAmountField" />
                        </td>
                        <td class="control">
                          <UI:TextBox id="DeliveryChargeAmountField" runat="server" Template-PropertyName="DeliveryChargesPrice" ExtendedTemplate-HighlightOnFocus="true" />
                        </td>
                      </tr>
                      
                      <tr class="<%=GetRegionCSSClass(GrandTotalField)%>">
                        <td class="label">
                          <UI:FieldView runat="server" ID="GrandTotalFieldView" InputToDisplayID="GrandTotalField" />
                        </td>
                        <td class="control">
                          <UI:TextBox id="GrandTotalField" runat="server" Template-PropertyName="GrandTotal" ExtendedTemplate-HighlightOnFocus="true" />
                        </td>
                      </tr>                                             
                  </tbody>
                </table>
              </div>
            </Body>
          </Control:CollapsableBox>
        </fieldset>
      </td>
    </tr>
    <tr>
      <td>
        <uc:ButtonsPanel runat="server" ID="Buttons" />
        <span class="obligatory-fields"><%=UI.Current.RequiredMessage %></span>
      </td>
    </tr>
  </tbody>
</table>
