﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="ProductListing.ascx.cs" Inherits="Core.Web.Admin.Controls.Listing.ProductListing" %>

<%@ Import Namespace="Core.Web" %>
<%@ Register Namespace="Core.Web.Objects.Controls.ProductFilters" assembly="Core.Web" tagPrefix="UI"%>

<table class="data" cellpadding="0" cellspacing="15" border="0">
  <tbody>
    <tr>
      <td>
        <Filter:FiltersArea runat="server" ID="Filters">
          <Filters>
            <UI:FilterTextBox runat="server" ID="SearchBox" />
            <UI:FilterDropDownList runat="server" ID="ModelTypeFilter" PropertyName="ProductType" />
            <UI:FilterDropDownList runat="server" ID="ManufacturerFilter" PropertyName="Manufacturer" />
            <UI:FilterDropDownList runat="server" ID="SupplierFilter" PropertyName="Supplier" />
            <UI:CategoryFilter runat="server" ID="CategoryFilter" TitleKey="Category" />
          </Filters>
        </Filter:FiltersArea>
      </td>
    </tr>
    <tr>
      <td>
        <UI:ActionResultView runat="server" ID="CustomActionResult" />
      </td>
    </tr>
    <tr>
      <td>
        <Grid:ProductGridView runat="server" ID="Grid">
          <Columns>
            <List:GridColumn Header="Title" PropertyName="Title" Width="23" />
            <List:GridColumn Header="Reference" PropertyName="Reference" Width="23" />
            <List:GridColumn Header="Type" PropertyName="ProductType.Name" Width="23" />
            <List:MoneyGridColumn Header="Price" PropertyName="Price" Width="23" />
          </Columns>
          <ActionColumns>
            <List:DetailsActionColumn Width="3" CssClass="butt-edit png cursor-hand" InactiveCssClass="inactive-action-column" />
            <List:DeleteActionColumn Width="3" CssClass="butt-delete png cursor-hand" InactiveCssClass="inactive-action-column" />
          </ActionColumns>
        </Grid:ProductGridView>
      </td>
    </tr>
    <tr>
      <td>
        <List:ItemsCounter runat="server" ID="ItemsCounter" />

        <span class="grid-area-filter-item">

          <label class="line-label">
            <%=PageSize.FieldView%></label>

          <List:PageSizeChanger runat="server" ID="PageSize" />
        </span>

        <List:Paginator runat="server" ID="GridPaginator" />
      </td>
    </tr>
  </tbody>
</table>
