﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="AccountDetails.ascx.cs" Inherits="Core.Web.Admin.Controls.Setup.AccountDetails" %>


<%@ Register Src="~/Admin/PageElements/SpanButton.ascx" TagPrefix="uc" TagName="SpanButton" %>

<table cellspacing="15" cellpadding="0" border="0" class="data">
  <tbody>
    <tr>
      <td class="form1">
        <div class="error"><UI:ValidationSummary runat="server" ID="Errors" /></div>
        <UI:ActionResultView runat="server" ID="CustomActionResult" />
        <fieldset>
          <div class="setup-tooltip">
            <p>Please enter Global Administrator credentials. Global Administrator has the unrestricted access to all the back office modules.</p>
            <p><strong>Important:</strong> make sure the password you type is secure (you may use the combinations of characters, digits, etc.). You can change password after installation via Administrator Profile.</p>
          </div>        
          <div style="height:10px;clear:both;"></div>
          <Control:CollapsableBox runat="server" ID="Messages" IsCollapsable="true">
            <Header>
              <h3 class="delimiter"><span>Global Administrator Details</span></h3>
            </Header>
            <Body>
              <div class="form-content">
                <table class="line-form">
                  <tbody>  
                    <tr class="<%=GetRegionCSSClass(LoginField)%>">
                      <td class="label label-50">
                        <UI:FieldView runat="server" ID="LoginFieldView" InputToDisplayID="LoginField" />
                      </td>
                      <td class="control">
                        <UI:TextBox ID="LoginField" runat="server"  ExtendedTemplate-HighlightOnFocus="true" Template-IsRequired="true" Template-DisplayName="Login"/>
                      </td>
                    </tr> 
                    <tr class="<%=GetRegionCSSClass(PasswordField)%>">
                      <td class="label label-50">
                        <UI:FieldView runat="server" ID="PasswordFieldView" InputToDisplayID="PasswordField" />
                      </td>
                      <td class="control">
                        <UI:TextBox ID="PasswordField" runat="server" TextMode="Password" ExtendedTemplate-HighlightOnFocus="true" Template-IsRequired="true" Template-DisplayName="Password"/>
                      </td>
                    </tr>
                    <tr class="<%=GetRegionCSSClass(ConfirmPasswordField)%>">
                      <td class="label label-50">
                        <UI:FieldView runat="server" ID="ConfirmPasswordFieldView" InputToDisplayID="ConfirmPasswordField" />
                      </td>
                      <td class="control">
                        <UI:TextBox ID="ConfirmPasswordField" runat="server" TextMode="Password" ExtendedTemplate-HighlightOnFocus="true" Template-IsRequired="true" Template-DisplayName="Confirm Password"/>
                      </td>
                    </tr>
                    <tr class="<%=GetRegionCSSClass(EmailField)%>">
                      <td class="label label-50">
                        <UI:FieldView runat="server" ID="EmailFieldView" InputToDisplayID="EmailField" />
                      </td>
                      <td class="control">
                        <UI:TextBox ID="EmailField" runat="server"  ExtendedTemplate-HighlightOnFocus="true" Template-IsRequired="true" Template-DisplayName="Email"/>
                      </td>
                    </tr>
                    <tr class="<%=GetRegionCSSClass(FirstNameField)%>">
                      <td class="label label-50">
                        <UI:FieldView runat="server" ID="FirstNameFieldView" InputToDisplayID="FirstNameField" />
                      </td>
                      <td class="control">
                        <UI:TextBox ID="FirstNameField" runat="server"  ExtendedTemplate-HighlightOnFocus="true" Template-IsRequired="true" Template-DisplayName="First Name"/>
                      </td>
                    </tr>
                    <tr class="<%=GetRegionCSSClass(LastNameField)%>">
                      <td class="label label-50">
                        <UI:FieldView runat="server" ID="LastNameFieldView" InputToDisplayID="LastNameField" />
                      </td>
                      <td class="control">
                        <UI:TextBox ID="LastNameField" runat="server"  ExtendedTemplate-HighlightOnFocus="true" Template-IsRequired="true" Template-DisplayName="Last Name"/>
                      </td>
                    </tr>                    
                  </tbody>
                </table>
              </div>
            </Body>
          </Control:CollapsableBox>
        </fieldset>      
      </td>
    </tr>
    <tr>
      <td>
        <uc:SpanButton runat="server" id="Previous" Title="Prev" ToolTip="Prev" />
        <uc:SpanButton runat="server" id="Next" Title="Next" ToolTip="Next" IsSubmitOnEnterKey="true" />        
        <span class="obligatory-fields">Fields designated in <b>bold</b> are obligatory</span>
      </td>
    </tr>
  </tbody>
</table>