﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="SmtpDetails.ascx.cs" Inherits="Core.Web.Admin.Controls.Setup.SmtpDetails" %>

<%@ Register Src="~/Admin/PageElements/SpanButton.ascx" TagPrefix="uc" TagName="SpanButton" %>

<table cellspacing="15" cellpadding="0" border="0" class="data">
  <tbody>
    <tr>
      <td class="form1">
        <div class="error"><UI:ValidationSummary runat="server" ID="Errors" /></div>
        <UI:ActionResultView runat="server" ID="CustomActionResult" />
        <fieldset>
          <div class="setup-tooltip">
            <p>Please enter SMTP details.</p>
          </div>        
          <div style="height:10px;clear:both;"></div>
          <Control:CollapsableBox runat="server" ID="Messages" IsCollapsable="true">
            <Header>
              <h3 class="delimiter"><span>SMTP details</span></h3>
            </Header>
            <Body>
              <div class="form-content">
                <table class="line-form">
                  <tbody>  
                    <tr class="<%=GetRegionCSSClass(SMTPServerField)%>">
                      <td class="label label-50">
                        <UI:FieldView runat="server" ID="SMTPServerFieldView" InputToDisplayID="SMTPServerField" />
                      </td>
                      <td class="control">
                        <UI:TextBox ID="SMTPServerField" runat="server"  ExtendedTemplate-HighlightOnFocus="true" Template-IsRequired="false" Template-DisplayName="SMTP Server"/>
                      </td>
                    </tr> 
                    <tr class="<%=GetRegionCSSClass(SMTPUserField)%>">
                      <td class="label label-50">
                        <UI:FieldView runat="server" ID="FTPUserFieldView" InputToDisplayID="SMTPUserField" />
                      </td>
                      <td class="control">
                        <UI:TextBox ID="SMTPUserField" runat="server"  ExtendedTemplate-HighlightOnFocus="true" Template-IsRequired="false" Template-DisplayName="User"/>
                      </td>
                    </tr>
                    <tr class="<%=GetRegionCSSClass(SMTPPasswordField)%>">
                      <td class="label label-50">
                        <UI:FieldView runat="server" ID="SMTPPasswordFieldView" InputToDisplayID="SMTPPasswordField" />
                      </td>
                      <td class="control">
                        <UI:TextBox ID="SMTPPasswordField" runat="server" TextMode="Password" ExtendedTemplate-HighlightOnFocus="true" Template-IsRequired="false" Template-DisplayName="Password"/>
                      </td>
                    </tr>
                    <tr class="<%=GetRegionCSSClass(ConfirmSMTPPasswordField)%>">
                      <td class="label label-50">
                        <UI:FieldView runat="server" ID="ConfirmSMTPPasswordFieldView" InputToDisplayID="ConfirmSMTPPasswordField" />
                      </td>
                      <td class="control">
                        <UI:TextBox ID="ConfirmSMTPPasswordField" runat="server" TextMode="Password" ExtendedTemplate-HighlightOnFocus="true" Template-IsRequired="false" Template-DisplayName="Confirm Password"/>
                      </td>
                    </tr>
                    
                  </tbody>
                </table>
              </div>
            </Body>
          </Control:CollapsableBox>
        </fieldset>      
      </td>
    </tr>
    <tr>
      <td>
        <uc:SpanButton runat="server" id="Previous" Title="Prev" ToolTip="Prev" />
        <uc:SpanButton runat="server" id="Next" Title="Next" ToolTip="Next" IsSubmitOnEnterKey="true" />        
        <span class="obligatory-fields">Fields designated in <b>bold</b> are obligatory</span>
      </td>
    </tr>
  </tbody>
</table>