﻿<%@ Control Language="C#" AutoEventWireup="true" CodeBehind="CategoryViewer.ascx.cs"
    Inherits="Core.Web.Admin.Controls.Viewer.CategoryViewer" %>
<%@ Import Namespace="Core.DBO.Service.Security" %>
<%@ Import Namespace="Core.DBO.Static" %>
<%@ Import Namespace="Core.Web.Objects.Utility" %>
<%@ Import Namespace="Core.DBO.Entity" %>
<%@ Import Namespace="Core.Web" %>
<%@ Import Namespace="Core.Web.Objects" %>
<%@ Import namespace="Core.Web.Constants.UI"%>
<%@ Import namespace="Core.DBO.Config.Categories"%>
<%@ Register Src="~/Admin/Controls/HorizontalButtonsPanel.ascx" TagPrefix="uc" TagName="ButtonsPanel" %>
<%@ Register Src="~/Admin/Controls/ProductImages.ascx" TagPrefix="uc" TagName="ProductImages" %>
<table cellspacing="15" cellpadding="0" border="0" class="data">
    <tbody>
        <tr>
            <td class="form1">
                <div class="error">
                    <UI:ValidationSummary runat="server" ID="Errors" />
                </div>
                <UI:ActionResultView runat="server" ID="CustomActionResult" />
                <fieldset>
                    <Control:CollapsableBox runat="server" ID="Messages" IsCollapsable="true">
                        <Header>
                            <h3 class="delimiter"><span><%=UI.Current.CategoryDetails %></span></h3>
                        </Header>
                        <Body>
                            <div class="form-content">
                                <table class="line-form-value">
                                    <tbody>
                                      <tr>
                                        <td class="label-value">
                                          <UI:FieldView runat="server" ID="NameFieldView" InputToDisplayID="NameLabel" />
                                        </td>
                                        <td class="control-value">
                                          <UI:Label ID="NameLabel" runat="server" Template-PropertyName="Name" />
                                        </td>
                                      </tr>
                                      <tr>
                                        <td class="label-value">
                                          <UI:FieldView runat="server" ID="ParentCategoryFieldView" InputToDisplayID="ParentCategoryLabel" />
                                        </td>
                                        <td class="control-value">
                                          <UI:Label ID="ParentCategoryLabel" runat="server" Template-PropertyName="ParentCategory.Name" Template-DisplayName="Parent Category"/>
                                        </td>
                                      </tr>
                                      <tr>
                                        <td class="label-value">
                                          <UI:FieldView runat="server" ID="MetaTitleFieldView" InputToDisplayID="MetaTitleLabel" />
                                        </td>
                                        <td class="control-value">
                                          <UI:Label ID="MetaTitleLabel" runat="server" Template-PropertyName="MetaTitle" />
                                        </td>
                                      </tr>
                                      <tr>
                                        <td class="label-value">
                                          <UI:FieldView runat="server" ID="MetaKeywordsFieldView" InputToDisplayID="MetaKeywordsLabel" />
                                        </td>
                                        <td class="control-value">
                                          <UI:Label ID="MetaKeywordsLabel" runat="server" Template-PropertyName="MetaKeywords" />
                                        </td>
                                      </tr>
                                      <tr>
                                        <td class="label-value">
                                          <UI:FieldView runat="server" ID="MetaDescriptionFieldView" InputToDisplayID="MetaDescriptionLabel" />
                                        </td>
                                        <td class="control-value">
                                          <UI:Label ID="MetaDescriptionLabel" runat="server" Template-PropertyName="MetaDescription" />
                                        </td>
                                      </tr>
                                      <tr>
                                        <td class="label-value">
                                          <label><%=CategoryConfig.Current.CreationDate %>:</label>
                                        </td>
                                        <td class="control-value">
                                          <UI:StaticLabel ID="CreationDateLabel" runat="server"/>
                                        </td>
                                      </tr>
                                      <tr>
                                        <td class="label-value">
                                          <label><%=CategoryConfig.Current.LastModifyDate %>:</label>
                                        </td>
                                        <td class="control-value">
                                          <UI:StaticLabel ID="LastModifyDateLabel" runat="server"/>
                                        </td>
                                      </tr>
                                      <tr>
                                        <td class="label-value">
                                        </td>
                                        <td class="control-value">
                                          <UI:BooleanLabel ID="SubscriptionOnlyLabel" runat="server" Template-PropertyName="SubscriptionOnly" />
                                        </td>
                                      </tr>
                                      <tr>
                                        <td class="label-value">
                                        </td>
                                        <td class="control-value">
                                          <UI:BooleanLabel ID="EnabledLabel" runat="server" Template-PropertyName="Enabled" />
                                        </td>
                                      </tr>
                                    </tbody>
                                </table>
                            </div>
                        </Body>
                    </Control:CollapsableBox>
                </fieldset>
                <fieldset>
                    <Control:CollapsableBox runat="server" ID="ImageBox" IsCollapsable="true">
                        <Header>
                            <h3 class="delimiter"><span><%=UI.Current.CategoryImageDetails %></span></h3>
                        </Header>
                        <Body>
                            <div class="form-content">
                                <table class="line-form-value">
                                    <tbody>
                                      <tr>
                                        <td class="label-value">
                                          <asp:Label runat="server" ID="ImageFieldView"/>
                                        </td>
                                        <td class="control-value">
                                          <uc:ProductImages ID="CategoryImages" runat="server" ImageWidth="200" ImageHeight="200"/>
                                        </td>
                                      </tr>
                                    </tbody>
                                </table>
                            </div>
                        </Body>
                    </Control:CollapsableBox>
                </fieldset>
            </td>
        </tr>
        <tr>
            <td>
                <uc:ButtonsPanel runat="server" ID="Buttons" />
            </td>
        </tr>
    </tbody>
</table>
